package dynamictaskflowidexceptionapp.view.util;

import java.io.Serializable;

import oracle.adf.controller.TaskFlowId;

public class TaskFlowManager
	implements Serializable
{
	private String fTaskFlowId = "/WEB-INF/btf/some-btf.xml#some-btf";

	public TaskFlowId getDynamicTaskFlowId()
	{
//		return TaskFlowId.parse(fTaskFlowId);
//		return getDynamicTaskFlowIdThrowingException();
		return getDynamicTaskFlowIdCatchingExceptionReturningNull();
	}

	public String getDynamicTaskFlowIdAsString()
	{
		TaskFlowId vDynamicTaskFlowId = getDynamicTaskFlowId();
		if (vDynamicTaskFlowId != null)
		{
			return vDynamicTaskFlowId.getFullyQualifiedName();
		}
		else
		{
			return ""; // as suggested by Duncan Mills at https://java.net/jira/browse/ADFEMG-141
		}
	}

	public TaskFlowId getDynamicTaskFlowIdThrowingException()
	{
		throw new RuntimeException("unable to get dynamic TaskFlowId");
	}

	public TaskFlowId getDynamicTaskFlowIdCatchingExceptionReturningNull()
	{
		try
		{
			return getDynamicTaskFlowIdThrowingException();
		}
		catch(Exception ex)
		{
			return null;
		}
	}
}
